﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI;

namespace RadGridViewBehaviorDemo
{
    public class MyCutomGridBehavior : BaseGridBehavior
    {
        public override bool ProcessKeyDown(KeyEventArgs keys)
        {
            if (ProcessNavigationalKeys(keys))
            {
                return true;
            }
            else
            {
                return base.ProcessKeyDown(keys);
            }
        }

        public override bool ProcessKey(KeyEventArgs keys)
        {
            if (ProcessNavigationalKeys(keys))
            {
                return true;
            }
            else
            {
                return base.ProcessKey(keys);
            }
        }

        private bool ProcessNavigationalKeys(KeyEventArgs keys)
        {
            if (this.GridControl.CurrentRow is GridViewFilteringRowInfo)
            {
                int columnIndex = this.GridControl.CurrentColumn.Index;

                if ((keys.KeyCode == Keys.Tab && !keys.Shift) || keys.KeyCode == Keys.Right)
                {
                    if (columnIndex < this.GridControl.Columns.Count - 1)
                    {
                        this.GridControl.Columns[columnIndex + 1].IsCurrent = true;

                        return true;
                    }
                }
                else if ((keys.KeyCode == Keys.Tab && keys.Shift) || keys.KeyCode == Keys.Left)
                {
                    if (columnIndex > 0)
                    {
                        this.GridControl.Columns[columnIndex - 1].IsCurrent = true;

                        return true;
                    }
                }
            }

            return false;
        }
    }
}
